#!/usr/local/bin/perl

$start_dir = "../";
$file_error = "Could not open file.";

$color_default = "green";
$light_default = "A5E9A5";
$dark_default = "007A00";

# Read arguments from command line COLOR FILE
#
if ($#ARGV == 1) {
   $color = @ARGV[0];
   $file = @ARGV[1];

   # Don't leave this directory tree!
   # 
   if ($file =~ /\.\./) {
      print "Attempt to leave directory for: $file\n";
      exit(0);
   }
}
else {
   print "Usage: color.cgi COLOR FILE\n";
   exit(0);
} 

# convert color to value
#
if ($color eq "red") {
   $light_color = "E9A5A5";
   $dark_color = "7A0000";
}
elsif ($color eq "blue") {
   $light_color = "A5A5E9";
   $dark_color = "00007A";
}
elsif ($color eq "yellow") {
   $light_color = "E9E9A5";
   $dark_color = "7A7A00";
}
elsif ($color eq "purple") {
   $light_color = "E9A5E9";
   $dark_color = "7A007A";
}
else {
   $light_color = $light_default;
   $dark_color = $dark_default;
}

# read file to convert
#
$location = $start_dir.$file;
if (!open(FILE, $location)) {
   print "$file_error: $location\n";
   exit 0;
}
else {
   @data = <FILE>;
}
close(FILE);

# Convert and output
#
print "Content-Type: text/html \n\n";

foreach $data (@data) {
   # replace netscape colors
   if ($data =~ /color/) {
      $data =~ s/$dark_default/$dark_color/g;
      $data =~ s/$light_default/$light_color/g;
   }
   # replace image colors
   if ($data =~ /href/) {
      $data =~ s/$color_default/$color/g;
   }
   print $data;
}
