#!/usr/local/bin/perl

$file = "picture.html";
$file_error = "Could not open file.";

$color_default = "green";
$light_default = "A5E9A5";
$dark_default = "007A00";

# Read arguments from command line COLOR PHOTO TEXT
#
if ($#ARGV == 2) {
   $color = @ARGV[0];
   $photo = @ARGV[1];
   $text = @ARGV[2];
}
else {
   print "Usage: picture.cgi COLOR PHOTO TEXT\n";
   exit(0);
} 

# convert color to value
#
if ($color eq "red") {
   $light_color = "E9A5A5";
   $dark_color = "7A0000";
}
elsif ($color eq "blue") {
   $light_color = "A5A5E9";
   $dark_color = "00007A";
}
elsif ($color eq "yellow") {
   $light_color = "E9E9A5";
   $dark_color = "7A7A00";
}
elsif ($color eq "purple") {
   $light_color = "E9A5E9";
   $dark_color = "7A007A";
}
else {
   $light_color = $light_default;
   $dark_color = $dark_default;
}

# read file to convert
#
if (!open(FILE, $file)) {
   print "$file_error: $file\n";
   exit 0;
}
else {
   @data = <FILE>;
}
close(FILE);

# Convert and output
#
print "Content-Type: text/html \n\n";

$status = 0;
foreach $data (@data) {
   if ($status == 1) {
      $status = 0;
   }
   else {
      # replace netscape colors
      if ($data =~ /color/) {
         $data =~ s/$dark_default/$dark_color/g;
         $data =~ s/$light_default/$light_color/g;
      }
      # replace image colors
      if ($data =~ /href/) {
         $data =~ s/$color_default/$color/g;
      }
      # replace Photo
      if ($data =~ /PHOTO/) {
         $moredata = "<img src=\"../gallery/pictures/gallery_$photo.gif\" hspace=\"40\" vspace=\"20\">\n";
         $status = 1;
      }
      # replace Photo
      if ($data =~ /TEXT/) {
         $text =~ tr/_/ /;
         $text =~ tr/\\/ /;
         $moredata = "<i><font size=\"+2\">$text</font></i>\n";
         $status = 1;
      }

      print $data;
      if ($status == 1) {
         print $moredata;
      }
   }
}
