#!/user/a61/perl/bin/perl
# #!/usr/local/bin/perl

use GD;

# initialize
$input_postcard="pictures/postcard.gif";
$extension=".gif";
$note = "Keukenhof, The Netherlands";


# Read arguments from command line
# make inputs
if ($#ARGV == 1) {
   $message_input = @ARGV[0];
   $flower_input = @ARGV[1];
}
else {
   print "Usage: createPostcard.cgi [MESSAGE FLOWER]\n";
   exit(0);
} 
$input_text="$message_input";
$input_picture="pictures/$flower_input";
$input_picture=$input_picture.$extension;
$flower_input =~ /([^_]*)_(.*)/;
$input_color=$2;


# Read empty postcard
if ( open (IMIN1, "$input_postcard") ) {
   $postcard = newFromGif GD::Image(IMIN1);
   close (IMIN1);
}
else {
   exit 0;
}


# Read picture to put in postcard
if ( open (IMIN2, "$input_picture") ) {
   $picture = newFromGif GD::Image(IMIN2);
   close (IMIN2);
}
else {
   exit 0;
}


# Colors
if ($input_color eq "green") {
   $text_color = $postcard->colorAllocate(0,122,0);
   $bg_color = $postcard->colorAllocate(168,233,168);
}
if ($input_color eq "red") {
   $text_color = $postcard->colorAllocate(122,0,0);
   $bg_color = $postcard->colorAllocate(233,168,168);
}
if ($input_color eq "blue") {
   $text_color = $postcard->colorAllocate(0,0,122);
   $bg_color = $postcard->colorAllocate(168,168,233);
}
if ($input_color eq "yellow") {
   $text_color = $postcard->colorAllocate(122,122,0);
   $bg_color = $postcard->colorAllocate(233,233,168);
}
if ($input_color eq "purple") {
   $text_color = $postcard->colorAllocate(122,0,122);
   $bg_color = $postcard->colorAllocate(233,168,233);
}


# Change Background
$postcard->fill(25,25,$bg_color);


# Place the text
# - 25 grote karakters passen binnen 200 pixels
# - Dit is 8 pixels per groot karakter
if ( ! ($input_text eq "No") ) {
   $Large_Length=25;
   $Large_Pixel=8;
   $Large_Height="30";

   # - string: font, destX, destY, string, color
   # - font: gdSmallFont, gdLargeFont, gdMediumBoldFont (12pt), gdTinyFont
   @words_text=split(/_/, $input_text);
   $count=0;
   foreach $word (@words_text) {
      $length_word = length($word);
      $length_diff = $Large_Length - $length_word;
      $length_diff = int($length_diff / 2);
      $offset = ( $length_diff * $Large_Pixel ) - 1;
      $postcard->string(gdLargeFont, 50 + $offset, 90 + $count, $word, $text_color);
      $count=$count + $Large_Height;
   }
}


# A note
$black = $postcard->colorAllocate(0,0,0);
$postcard->string(gdMediumBoldFont, 50, 238, $note, $black);


# Place the picture
# - copy: source, destX, destY, srcX, srcY, Width, Height
# - copyResized: source, destX, destY, srcX, srcY, destW, destH, srcW, srcH
($picture_width, $picture_height) = $picture->getBounds();
$postcard->copyResized($picture, 250, 50, 0, 0, 199, 199, $picture_width, $picture_height);


# output
print "Content-Type: image/gif\n\n";
print $postcard->gif;
